{{- if .Values.workers -}}
apiVersion: v1
kind: List
items:
{{- range $workerName, $workerConfig :=  .Values.workers }}
- apiVersion: apps/v1
  kind: Deployment
  metadata:
    name: {{ template "trackableappname" $ }}-{{ $workerName }}
    labels:
      track: "{{ $.Values.application.track }}"
      tier: worker
      chart: "{{ $.Chart.Name }}-{{ $.Chart.Version | replace "+" "_" }}"
      release: {{ $.Release.Name }}
      heritage: {{ $.Release.Service }}
  spec:
    replicas: {{ $workerConfig.replicaCount }}
    selector:
      matchLabels:
        app: {{ template "trackableappname" $ }}-{{ $workerName }}
        track: "{{ $.Values.application.generic.track }}"
        tier: {{ $.Values.application.generic.tier}}-{{ $workerName }}
        release: {{ $.Release.Name }}
    template:
      metadata:
        labels:
          app: {{ template "trackableappname" $ }}-{{ $workerName }}
          track: "{{ $.Values.application.generic.track }}"
          tier: {{ $.Values.application.generic.tier}}-{{ $workerName }}
          release: {{ $.Release.Name }}
      spec:
        imagePullSecrets:
          - name: "registry-secret"
        {{- include "wait_for" $ | nindent 8 }}
        terminationGracePeriodSeconds: {{ $workerConfig.terminationGracePeriodSeconds }}
        containers:
        - name: {{ $.Chart.Name }}-{{ $workerName }}
          image: "{{ $.Values.image.repository }}:{{ $.Values.image.tag }}"
          command:
{{ toYaml $workerConfig.command | indent 12 }}
          imagePullPolicy: {{ $.Values.image.pullPolicy }}
          {{- if $.Values.application.secretName }}
          envFrom:
          - secretRef:
              name: {{ $.Values.application.secretName }}
          {{- end }}
          ports:
            - name: "delve"
              containerPort: 2345
            - name: "http"
              containerPort: {{ $.Values.service.internalPort }}
          env:
            - name: APP_PORT
              value: {{ $.Values.service.internalPort | quote }}
            - name: GITLAB_ENVIRONMENT_NAME
              value: {{ $.Values.gitlab.envName }}
            - name: GITLAB_ENVIRONMENT_URL
              value: {{ $.Values.gitlab.envURL }}
            - name: DATABASE_URL
              value: {{ $.Values.application.database_url | quote }}
            - name: DATABASE_DRIVER
              value: {{ $.Values.application.database_driver | quote}}
            {{- if $.Values.rabbitmq.enabled }}
            - name: RABBITMQ_HOST
              value: {{ $.Values.application.rabbitmq.host }}
            - name: RABBITMQ_PORT
              value: {{ $.Values.application.rabbitmq.port | quote }}
            - name: RABBITMQ_PASSWORD
              value: {{ $.Values.application.rabbitmq.password }}
            - name: RABBITMQ_USER
              value: {{ $.Values.application.rabbitmq.user }}
            {{- end}}
            {{- if $.Values.redis.enabled }}
            - name: REDIS_PORT
              value: {{ $.Values.application.redis.port | quote }}
            - name: REDIS_PASSWORD
              value: {{ $.Values.application.redis.password }}
            - name: REDIS_HOST
              value: {{ $.Values.application.redis.host }}
            {{- end}}
{{- if $.Values.application.environments }}
{{ toYaml $.Values.application.environments | indent 12 }}
{{- end }}
          resources:
{{ toYaml $.Values.resources | indent 12 }}
{{- end -}}
{{- end -}}
